diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/nntplib.c tin-2.6.5/src/nntplib.c
--- tin-2.6.4/src/nntplib.c	2024-12-21 02:56:55.000000000 +0100
+++ tin-2.6.5/src/nntplib.c	2025-12-18 19:40:47.309138047 +0100
@@ -1229,243 +1324,327 @@ check_extensions(
 
 	buf[0] = '\0';
 
-	/* rvl > 0 = manually send "CAPABILITIES" to avoid endless AUTH loop */
-	i = rvl ? rvl : new_nntp_command("CAPABILITIES", INF_CAPABILITIES, buf, sizeof(buf));
-	switch (i) {
-		case INF_CAPABILITIES:
-			/* clear capabilities */
-			nntp_caps.type = CAPABILITIES;
-			nntp_caps.version = 0;
-			nntp_caps.mode_reader = FALSE;
-			nntp_caps.reader = FALSE;
-			nntp_caps.post = FALSE;
-			nntp_caps.list_active = FALSE;
-			nntp_caps.list_active_times = FALSE;
-			nntp_caps.list_distrib_pats = FALSE;
-			nntp_caps.list_headers = FALSE;
-			FreeAndNull(nntp_caps.headers_range);
-			FreeAndNull(nntp_caps.headers_id);
-			nntp_caps.list_newsgroups = FALSE;
-			nntp_caps.list_overview_fmt = FALSE;
-			nntp_caps.list_motd = FALSE;
-			nntp_caps.list_subscriptions = FALSE;
-			nntp_caps.list_distributions = FALSE;
-			nntp_caps.list_moderators = FALSE;
-			nntp_caps.list_counts = FALSE;
-			nntp_caps.xpat = TRUE; /* toggles to false if fails, INN > 2.7.0 announces it */
-			nntp_caps.hdr = FALSE;
-			nntp_caps.hdr_cmd = NULL;
-			nntp_caps.over = FALSE;
-			nntp_caps.over_msgid = FALSE;
-			nntp_caps.over_cmd = NULL;
-			nntp_caps.newnews = FALSE;
-			FreeAndNull(nntp_caps.implementation);
-			nntp_caps.starttls = FALSE;
-			nntp_caps.authinfo_user = FALSE;
-			nntp_caps.authinfo_sasl = FALSE;
-			nntp_caps.authinfo_state = FALSE;
-			FreeAndNull(nntp_caps.sasl_mechs);
-			/* nntp_caps.sasl_mech_used will be init in sasl_auth() */
-			nntp_caps.compress = FALSE;
-			nntp_caps.compress_algorithm = COMPRESS_NONE;
-			/* nntp_caps.maxartnum will be init it nntp_open() */
+	if (nntp_caps.type != BROKEN) { /* CAPABILITIES disabled? */
+		/* rvl > 0 = manually send "CAPABILITIES" to avoid endless AUTH loop */
+		i = rvl ? rvl : new_nntp_command("CAPABILITIES", INF_CAPABILITIES, buf, sizeof(buf));
+		switch (i) {
+			case INF_CAPABILITIES:
+				/* clear capabilities */
+				nntp_caps.type = CAPABILITIES;
+				nntp_caps.version = 0;
+				nntp_caps.mode_reader = FALSE;
+				nntp_caps.reader = FALSE;
+				nntp_caps.post = FALSE;
+				nntp_caps.list_active = FALSE;
+				nntp_caps.list_active_times = FALSE;
+				nntp_caps.list_distrib_pats = FALSE;
+				nntp_caps.distrib_pats = NULL;
+				nntp_caps.list_headers = FALSE;
+				FreeAndNull(nntp_caps.headers_range);
+				FreeAndNull(nntp_caps.headers_id);
+				nntp_caps.list_newsgroups = FALSE;
+				nntp_caps.list_overview_fmt = FALSE;
+				nntp_caps.list_motd = FALSE;
+				nntp_caps.list_subscriptions = FALSE;
+				nntp_caps.list_distributions = FALSE;
+				nntp_caps.list_moderators = FALSE;
+				nntp_caps.list_counts = FALSE;
+				nntp_caps.listgroup = FALSE;
+				nntp_caps.xpat = FALSE;
+				nntp_caps.hdr = FALSE;
+				nntp_caps.hdr_cmd = NULL;
+				nntp_caps.over = FALSE;
+				nntp_caps.over_msgid = FALSE;
+				nntp_caps.over_cmd = NULL;
+				nntp_caps.newgroups = TRUE;	/* not listed in CAPABILITIES */
+#if 0
+				nntp_caps.newnews = FALSE;
+#endif /* 0 */
+				FreeAndNull(nntp_caps.implementation);
+				nntp_caps.starttls = FALSE;
+				nntp_caps.authinfo_user = FALSE;
+				nntp_caps.authinfo_sasl = FALSE;
+				nntp_caps.authinfo_state = FALSE;
+				FreeAndNull(nntp_caps.sasl_mechs);
+				/* nntp_caps.sasl_mech_used will be init in sasl_auth() */
+				nntp_caps.compress = FALSE;
+				nntp_caps.compress_algorithm = COMPRESS_NONE;
+				/* nntp_caps.maxartnum will be init it nntp_open() */
 #	if 0
-			nntp_caps.streaming = FALSE;
-			nntp_caps.ihave = FALSE;
+				nntp_caps.streaming = FALSE;
+				nntp_caps.ihave = FALSE;
 #	endif /* 0 */
-#	ifndef BROKEN_LISTGROUP
-			nntp_caps.broken_listgroup = FALSE;
-#	else
-			nntp_caps.broken_listgroup = TRUE;
-#	endif /* !BROKEN_LISTGROUP */
 
-			while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+				while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
 #	ifdef DEBUG
-				if (debug & DEBUG_NNTP)
-					debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+					if (debug & DEBUG_NNTP)
+						debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
 #	endif /* DEBUG */
-				/* look for version number(s) */
-				if (!nntp_caps.version && nntp_caps.type == CAPABILITIES) {
-					if (!strncasecmp(ptr, "VERSION", 7)) {
-						if (strtok(ptr, WS) != NULL) { /* skip initial VERSION */
-							unsigned int v, j;
-
-							while ((d = strtok(NULL, WS)) != NULL) { /* find highest version we do support */
-								v = (unsigned int) s2i(d, 2, INT_MAX);
-								for (j = 0; cap_vers[j]; j++) {
-									if (v == cap_vers[j])
-										nntp_caps.version = MAX(nntp_caps.version, v);
+					/* look for version number(s) */
+					if (!nntp_caps.version && nntp_caps.type == CAPABILITIES) {
+						if (!strncasecmp(ptr, "VERSION", 7)) {
+							if (strtok(ptr, WS) != NULL) { /* skip initial VERSION */
+								unsigned int v, j;
+
+								while ((d = strtok(NULL, WS)) != NULL) { /* find highest version we do support */
+									v = (unsigned int) s2i(d, 2, INT_MAX);
+									for (j = 0; cap_vers[j]; j++) {
+										if (v == cap_vers[j])
+											nntp_caps.version = MAX(nntp_caps.version, v);
+									}
 								}
 							}
 						}
 					}
-				}
-				/* CAPABILITIES VERSION 2 (we currently only support that) */
-				if (nntp_caps.version == 2) {
-					/* check for LIST variants */
-					if (!strncasecmp(ptr, "LIST", 4)) {
-						if (strtok(ptr, WS) != NULL) { /* skip initial LIST */
-							while ((d = strtok(NULL, WS)) != NULL) {
-								if (!strcasecmp(d, "ACTIVE.TIMES"))
-									nntp_caps.list_active_times = TRUE;
-								else if (!strcasecmp(d, "ACTIVE"))
-									nntp_caps.list_active = TRUE;
-								else if (!strcasecmp(d, "DISTRIB.PATS"))
-									nntp_caps.list_distrib_pats = TRUE;
-								else if (!strcasecmp(d, "DISTRIBUTIONS")) /* RFC 6048 */
-									nntp_caps.list_distributions = TRUE;
-								else if (!strcasecmp(d, "HEADERS"))
-									nntp_caps.list_headers = TRUE; /* HDR requires LIST HEADERS, but not vice versa */
-								else if (!strcasecmp(d, "NEWSGROUPS"))
-									nntp_caps.list_newsgroups = TRUE;
-								else if (!strcasecmp(d, "OVERVIEW.FMT")) /* OVER requires OVERVIEW.FMT, but not vice versa */
-									nntp_caps.list_overview_fmt = TRUE;
-								else if (!strcasecmp(d, "MOTD")) /* RFC 6048 */
-									nntp_caps.list_motd = TRUE;
-								else if (!strcasecmp(d, "SUBSCRIPTIONS")) /* RFC 6048 */
-									nntp_caps.list_subscriptions = TRUE;
-								else if (!strcasecmp(d, "MODERATORS")) /* RFC 6048 */
-									nntp_caps.list_moderators = TRUE;
-								else if (!strcasecmp(d, "COUNTS")) /* RFC 6048 */
-									nntp_caps.list_counts = TRUE;
+					/* CAPABILITIES VERSION 2 (we currently only support that) */
+					if (nntp_caps.version == 2) {
+						/* check for LIST variants */
+						if (!strncasecmp(ptr, "LIST", 4)) {
+							if (strtok(ptr, WS) != NULL) { /* skip initial LIST */
+								while ((d = strtok(NULL, WS)) != NULL) {
+									if (!strcasecmp(d, "ACTIVE.TIMES"))
+										nntp_caps.list_active_times = TRUE;
+									else if (!strcasecmp(d, "ACTIVE"))
+										nntp_caps.list_active = TRUE;
+									else if (!strcasecmp(d, "DISTRIB.PATS"))
+										nntp_caps.list_distrib_pats = TRUE;
+									else if (!strcasecmp(d, "DISTRIBUTIONS")) /* RFC 6048 */
+										nntp_caps.list_distributions = TRUE;
+									else if (!strcasecmp(d, "HEADERS"))
+										nntp_caps.list_headers = TRUE; /* HDR requires LIST HEADERS, but not vice versa */
+									else if (!strcasecmp(d, "NEWSGROUPS"))
+										nntp_caps.list_newsgroups = TRUE;
+									else if (!strcasecmp(d, "OVERVIEW.FMT")) /* OVER requires OVERVIEW.FMT, but not vice versa */
+										nntp_caps.list_overview_fmt = TRUE;
+									else if (!strcasecmp(d, "MOTD")) /* RFC 6048 */
+										nntp_caps.list_motd = TRUE;
+									else if (!strcasecmp(d, "SUBSCRIPTIONS")) /* RFC 6048 */
+										nntp_caps.list_subscriptions = TRUE;
+									else if (!strcasecmp(d, "MODERATORS")) /* RFC 6048 */
+										nntp_caps.list_moderators = TRUE;
+									else if (!strcasecmp(d, "COUNTS")) /* RFC 6048 */
+										nntp_caps.list_counts = TRUE;
+								}
 							}
-						}
-					} else if (!strncasecmp(ptr, "IMPLEMENTATION", 14)) {
-						FreeIfNeeded(nntp_caps.implementation);
-						nntp_caps.implementation = my_strdup(ptr + 14);
-						str_trim(nntp_caps.implementation);
-					} else if (!strcasecmp(ptr, "MODE-READER")) {
-						if (!nntp_caps.reader)
-							nntp_caps.mode_reader = TRUE;
-					} else if (!strcasecmp(ptr, "READER")) { /* if we saw READER, "LIST ACTIVE" and "LIST NEWSGROUPS" must be implemented */
-						nntp_caps.reader = TRUE;
-						nntp_caps.mode_reader = FALSE;
-						nntp_caps.list_newsgroups = TRUE;
-						nntp_caps.list_active = TRUE;
-					} else if (!strcasecmp(ptr, "POST"))
-						nntp_caps.post = TRUE;
-					else if (!strcasecmp(ptr, "NEWNEWS"))
-						nntp_caps.newnews = TRUE;
-					else if (!strcasecmp(ptr, "XPAT")) /* extension, RFC 2980 */
-						nntp_caps.xpat = TRUE;
-					else if (!strcasecmp(ptr, "STARTTLS"))
-						nntp_caps.starttls = TRUE;
-					/*
-					 * NOTE: if we saw OVER, LIST OVERVIEW.FMT _must_ be implemented
-					 */
-					else if (!strncasecmp(ptr, &xover_cmds[1], strlen(&xover_cmds[1]))) {
-						nntp_caps.list_overview_fmt = nntp_caps.over = TRUE;
-						nntp_caps.over_cmd = &xover_cmds[1];
-						if (strtok(ptr, WS) != NULL) {
-							while ((d = strtok(NULL, WS)) != NULL) {
-								if (!strcasecmp(d, "MSGID"))
-									nntp_caps.over_msgid = TRUE;
+						} else if (!strncasecmp(ptr, "IMPLEMENTATION", 14)) {
+							FreeIfNeeded(nntp_caps.implementation);
+							nntp_caps.implementation = my_strdup(ptr + 14);
+							str_trim(nntp_caps.implementation);
+						} else if (!strcasecmp(ptr, "MODE-READER")) {
+							if (!nntp_caps.reader)
+								nntp_caps.mode_reader = TRUE;
+						} else if (!strcasecmp(ptr, "READER")) { /* if we saw READER, "LIST ACTIVE" and "LIST NEWSGROUPS" must be implemented */
+							nntp_caps.reader = TRUE;
+							nntp_caps.mode_reader = FALSE;
+							nntp_caps.list_newsgroups = TRUE;
+							nntp_caps.list_active = TRUE;
+							nntp_caps.listgroup = TRUE;
+						} else if (!strcasecmp(ptr, "POST"))
+							nntp_caps.post = TRUE;
+#if 0
+						else if (!strcasecmp(ptr, "NEWNEWS"))
+							nntp_caps.newnews = TRUE;
+#endif /* 0 */
+						else if (!strcasecmp(ptr, "XPAT")) /* extension, RFC 2980 */
+							nntp_caps.xpat = TRUE;
+						else if (!strcasecmp(ptr, "STARTTLS"))
+							nntp_caps.starttls = TRUE;
+						/*
+						 * NOTE: if we saw OVER, LIST OVERVIEW.FMT _must_ be implemented
+						 */
+						else if (!strncasecmp(ptr, &xover_cmds[1], strlen(&xover_cmds[1]))) {
+							nntp_caps.list_overview_fmt = nntp_caps.over = TRUE;
+							nntp_caps.over_cmd = &xover_cmds[1];
+							if (strtok(ptr, WS) != NULL) {
+								while ((d = strtok(NULL, WS)) != NULL) {
+									if (!strcasecmp(d, "MSGID"))
+										nntp_caps.over_msgid = TRUE;
+								}
 							}
 						}
-					}
-					/*
-					 * NOTE: if we saw HDR, LIST HEADERS _must_ be implemented
-					 */
-					else if (!strncasecmp(ptr, &xhdr_cmds[1], strlen(&xhdr_cmds[1]))) {
-						nntp_caps.hdr_cmd = &xhdr_cmds[1];
-						nntp_caps.list_headers = nntp_caps.hdr = TRUE;
-						nntp_caps.headers_range = my_strdup("");
-						nntp_caps.headers_id = my_strdup("");
-					} else if (!strncasecmp(ptr, "AUTHINFO", 8)) {
-						if (strtok(ptr, WS) == NULL) /* AUTHINFO without args */
-							nntp_caps.authinfo_state = TRUE;
-						else {
-							while ((d = strtok(NULL, WS)) != NULL) {
-								if (!strcasecmp(d, "USER"))
-									nntp_caps.authinfo_user = TRUE;
-								if (!strcasecmp(d, "SASL"))
-									nntp_caps.authinfo_sasl = TRUE;
+						/*
+						 * NOTE: if we saw HDR, LIST HEADERS _must_ be implemented
+						 */
+						else if (!strncasecmp(ptr, &xhdr_cmds[1], strlen(&xhdr_cmds[1]))) {
+							nntp_caps.hdr_cmd = &xhdr_cmds[1];
+							nntp_caps.list_headers = nntp_caps.hdr = TRUE;
+							FreeIfNeeded(nntp_caps.headers_range);
+							nntp_caps.headers_range = my_strdup("");
+							FreeIfNeeded(nntp_caps.headers_id);
+							nntp_caps.headers_id = my_strdup("");
+						} else if (!strncasecmp(ptr, "AUTHINFO", 8)) {
+							if (strtok(ptr, WS) == NULL) /* AUTHINFO without args */
+								nntp_caps.authinfo_state = TRUE;
+							else {
+								while ((d = strtok(NULL, WS)) != NULL) {
+									if (!strcasecmp(d, "USER"))
+										nntp_caps.authinfo_user = TRUE;
+									if (!strcasecmp(d, "SASL"))
+										nntp_caps.authinfo_sasl = TRUE;
+								}
 							}
-						}
-					} else if (!strncasecmp(ptr, "SASL", 4)) {
-						nntp_caps.authinfo_sasl = FALSE;
-						FreeAndNull(nntp_caps.sasl_mechs);
-						nntp_caps.sasl_mechs = my_malloc(strlen(ptr) + 1); /* more than enough */
-						nntp_caps.sasl_mechs[0] = '\0';
-
-						if (strtok(ptr, WS) != NULL) { /* skip initial "SASL" */
-							int m;
-
-							while ((d = strtok(NULL, WS)) != NULL) {
-								m = 0;
-								while (tin_mechs[m]) { /* remember servers mechs we like */
-									if (!strcasecmp(d, tin_mechs[m])) {
-										strcat(nntp_caps.sasl_mechs, d);
-										strcat(nntp_caps.sasl_mechs, " ");
-										break;
+						} else if (!strncasecmp(ptr, "SASL", 4)) {
+							nntp_caps.authinfo_sasl = FALSE;
+							FreeAndNull(nntp_caps.sasl_mechs);
+							nntp_caps.sasl_mechs = my_malloc(strlen(ptr) + 1); /* more than enough */
+							nntp_caps.sasl_mechs[0] = '\0';
+
+							if (strtok(ptr, WS) != NULL) { /* skip initial "SASL" */
+								int m;
+
+								while ((d = strtok(NULL, WS)) != NULL) {
+									m = 0;
+									while (tin_mechs[m]) { /* remember servers mechs we like */
+										if (!strcasecmp(d, tin_mechs[m])) {
+											strcat(nntp_caps.sasl_mechs, d);
+											strcat(nntp_caps.sasl_mechs, " ");
+											break;
+										}
+										++m;
 									}
-									++m;
 								}
+								str_trim(nntp_caps.sasl_mechs);
+								if (*nntp_caps.sasl_mechs)
+									nntp_caps.authinfo_sasl = TRUE;
 							}
-							str_trim(nntp_caps.sasl_mechs);
-							if (*nntp_caps.sasl_mechs)
-								nntp_caps.authinfo_sasl = TRUE;
-						}
-					} else if (!strncasecmp(ptr, "COMPRESS", 8)) { /* RFC 8054 */
-						if (strtok(ptr, WS) != NULL) {
-							while ((d = strtok(NULL, WS)) != NULL) {
-								if (!strcasecmp(d, "DEFLATE")) {
-									nntp_caps.compress = TRUE;
-									nntp_caps.compress_algorithm |= COMPRESS_DEFLATE;
+						} else if (!strncasecmp(ptr, "COMPRESS", 8)) { /* RFC 8054 */
+							if (strtok(ptr, WS) != NULL) {
+								while ((d = strtok(NULL, WS)) != NULL) {
+									if (!strcasecmp(d, "DEFLATE")) {
+										nntp_caps.compress = TRUE;
+										nntp_caps.compress_algorithm |= COMPRESS_DEFLATE;
+									}
 								}
 							}
 						}
-					}
 #	if defined(MAXARTNUM) && defined(USE_LONG_ARTICLE_NUMBERS)
-					/*
-					 * MAXARTNUM - <tnqm14$35bas$1@news.trigofacile.com>
-					 *
-					 * if server responds with MAXARTNUM we (re)parse it
-					 * as we may have changed the state (auth) and it's
-					 * the servers job to not advertised MAXARTNUM again
-					 * after it had been used ...
-					 */
-					else if (!strncasecmp(ptr, "MAXARTNUM", 9) && nntp_caps.maxartnum == T_ARTNUM_CONST(0)) {
-						if (strtok(ptr, WS) != NULL) {
-							while ((d = strtok(NULL, WS)) != NULL)
-								nntp_caps.maxartnum = MIN(atoartnum(d), ARTNUM_MAX);
+						/*
+						 * MAXARTNUM - <tnqm14$35bas$1@news.trigofacile.com>
+						 *
+						 * if server responds with MAXARTNUM we (re)parse it
+						 * as we may have changed the state (auth) and it's
+						 * the servers job to not advertised MAXARTNUM again
+						 * after it had been used ...
+						 */
+						else if (!strncasecmp(ptr, "MAXARTNUM", 9) && nntp_caps.maxartnum == T_ARTNUM_CONST(0)) {
+							if (strtok(ptr, WS) != NULL) {
+								while ((d = strtok(NULL, WS)) != NULL)
+									nntp_caps.maxartnum = MIN(atoartnum(d), ARTNUM_MAX);
+							}
 						}
-					}
 #	endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
 #	if 0 /* we don't need these */
-					else if (!strcasecmp(ptr, "IHAVE"))
-						nntp_caps.ihave = TRUE;
-					else if (!strcasecmp(ptr, "STREAMING"))
-						nntp_caps.streaming = TRUE;
+						else if (!strcasecmp(ptr, "IHAVE"))
+							nntp_caps.ihave = TRUE;
+						else if (!strcasecmp(ptr, "STREAMING"))
+							nntp_caps.streaming = TRUE;
 #	endif /* 0 */
-				/* XZVER, XZHDR, ... */
-				} else
-					nntp_caps.type = NONE;
-			}
-			break;
+					/* XZVER, XZHDR, ... */
+					} else
+						nntp_caps.type = NONE;
+				}
+				break;
 
-		/*
-		 * XanaNewz 2 Server Version 2.0.0.3 doesn't know CAPABILITIES
-		 * but responds with 400 _without_ closing the connection. If
-		 * you use tin on a XanaNewz 2 Server comment out the following
-		 * case.
-		 */
+			/*
+			 * XanaNewz 2 Server Version 2.0.0.3 doesn't know CAPABILITIES
+			 * but responds with 400 _without_ closing the connection. If
+			 * you use tin on a XanaNewz 2 Server comment out the following
+			 * case (or use serverrc:disabled_nntp_cmds=CAPABILITIES).
+			 */
 #	if 1
-		case ERR_GOODBYE:
-			ret = i;
-			error_message(2, "%s", buf);
-			break;
+			case ERR_GOODBYE:
+				ret = i;
+				error_message(2, "%s", buf);
+				break;
 #	endif /* 1 */
 
-		default:
-			break;
-	}
+			default:
+				break;
+		}
 
 #	if defined(MAXARTNUM) && defined(USE_LONG_ARTICLE_NUMBERS)
-	if (nntp_caps.maxartnum <= T_ARTNUM_CONST(2147483647)) /* RFC 3977 "Article numbers MUST lie between 1 and 2,147,483,647, inclusive." */
-		nntp_caps.maxartnum = T_ARTNUM_CONST(0);
+		if (nntp_caps.maxartnum <= T_ARTNUM_CONST(2147483647)) /* RFC 3977 "Article numbers MUST lie between 1 and 2,147,483,647, inclusive." */
+			nntp_caps.maxartnum = T_ARTNUM_CONST(0);
 #	endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
 
+	}
+
+	/*
+	 * disable NNTP cmds if requested
+	 * takes comma separated list of NNTP commands
+	 *
+	 * TODO: - remember what got disabled so we don't have to
+	 *         strstr(serverrc.disabled_nntp_cmds, CMD)
+	 *         in the rest of the code to figure it out again.
+	 *       - move to a separate function so it can be called
+	 *         from the serverrc-menu in the
+	 *         OPT_SERVERRC_DISABLED_NNTP_CMDS case (and reflect
+	 *         the change right away and not just after a restart)?
+	 *         be aware that removing strings from the option may
+	 *         need to recheck capabilities anyway (and if
+	 *         CAPABILITIES is added it would be sent once more).
+	 *
+	 * NOTE: keep in sync with valid_suppressions in read_server_config()
+	 */
+	if (*serverrc.disabled_nntp_cmds) {
+		s = ptr = my_strdup(serverrc.disabled_nntp_cmds);
+		while ((d = strtok(s, ",")) != NULL) {
+			str_trim(d);
+			/* no check for "CAPABILITIES" here */
+			if (!strcasecmp(d, "AUTHINFO SASL")) /* disables _any_ AUTHINFO SASL mech */
+				nntp_caps.authinfo_sasl = FALSE;
+			else if (!strcasecmp(d, "COMPRESS DEFLATE")) {
+				nntp_caps.compress = FALSE;
+				nntp_caps.compress_algorithm = COMPRESS_NONE;
+			}
+			else if (!strcasecmp(d, "HDR")) {
+				nntp_caps.hdr = FALSE;
+				nntp_caps.hdr_cmd = NULL;
+				nntp_caps.list_headers = FALSE;
+			}
+			else if (!strcasecmp(d, "LIST COUNTS"))
+				nntp_caps.list_counts = FALSE;
+			else if (!strcasecmp(d, "LIST DISTRIB.PATS"))
+				nntp_caps.list_distrib_pats = FALSE;
+			else if (!strcasecmp(d, "LIST DISTRIBUTIONS"))
+				nntp_caps.list_distributions = FALSE;
+			else if (!strcasecmp(d, "LIST HEADERS"))
+				nntp_caps.list_headers = FALSE;
+			else if (!strcasecmp(d, "LIST MOTD"))
+				nntp_caps.list_motd = FALSE;
+			else if (!strcasecmp(d, "LIST NEWSGROUPS")) {
+				nntp_caps.list_newsgroups = FALSE;
+				show_description = FALSE;
+			}
+			else if (!strcasecmp(d, "LIST OVERVIEW.FMT"))
+				nntp_caps.list_overview_fmt = FALSE;
+			else if (!strcasecmp(d, "LIST SUBSCRIPTIONS"))
+				nntp_caps.list_subscriptions = FALSE;
+			else if (!strcasecmp(d, "LISTGROUP"))
+				nntp_caps.listgroup = FALSE;
+			else if (!strcasecmp(d, "NEWGROUPS")) {
+				nntp_caps.newgroups = FALSE;
+				check_for_new_newsgroups = FALSE;
+			}
+			else if (!strcasecmp(d, "OVER")) {
+				nntp_caps.over = FALSE;
+				nntp_caps.over_cmd = NULL;
+			}
+			else if (!strcasecmp(d, "XHDR")) { /* --disable-xhdr-xref */
+				nntp_caps.hdr = FALSE;
+				nntp_caps.hdr_cmd = NULL;
+			}
+			else if (!strcasecmp(d, "XOVER")) {
+				nntp_caps.over = FALSE;
+				nntp_caps.over_cmd = NULL;
+			}
+			else if (!strcasecmp(d, "XPAT"))
+				nntp_caps.xpat = FALSE;
+			/* add more cms. if required. e.g. NEWNEWS if we ever use it */
+			s = NULL;
+		}
+		free(ptr);
+	}
 	return ret;
 }
 
@@ -1485,7 +1664,7 @@ mode_reader(
 		if ((debug & DEBUG_NNTP) && verbose > 1)
 			debug_print_file("NNTP", "mode_reader(MODE READER)");
 #	endif /* DEBUG */
-		DEBUG_IO((stderr, "nntp_command(MODE READER)\n"));
+		DEBUG_IO((stderr, "%snntp_command(MODE READER)\n", logtime()));
 		put_server("MODE READER", FALSE);
 
 		/*
@@ -1580,8 +1759,12 @@ nntp_open(
 		debug_print_file("NNTP", "nntp_open() %s:%u", nntp_server, nntp_tcp_port);
 #	endif /* DEBUG */
 
+#if defined(HAVE_ALARM) && defined(SIGALRM)
+	alarm((unsigned) TIN_NNTP_TIMEOUT);
+#endif /* HAVE_ALARM && SIGALRM */
+
 	ret = server_init(nntp_server, NNTP_TCP_NAME, nntp_tcp_port, line, sizeof(line));
-	DEBUG_IO((stderr, "server_init returns %d,%s\n", ret, line));
+	DEBUG_IO((stderr, "%sserver_init returns %d,%s\n", logtime(), ret, line));
 
 	if ((!batch_mode || verbose) && ret >= 0 && !use_nntps)
 		my_fputc('\n', stdout);
@@ -1621,7 +1804,7 @@ nntp_open(
 			if (ret < 0)
 				error_message(2, _(txt_failed_to_connect_to_server), nntp_server);
 			else
-				error_message(2, "%s", line);
+				error_message(2, "%3.3d %s", ret, line);
 
 			return ret;
 	}
@@ -1649,8 +1832,7 @@ nntp_open(
 	 *       of extensions. (For details about authentication methods, see
 	 *       RFC 4643).
 	 */
-	if (nntp_caps.type != BROKEN)
-		check_extensions(0);
+	check_extensions(0);
 
 	/*
 	 * If the user wants us to authenticate on connection startup, do it now.
@@ -1768,11 +1950,12 @@ nntp_open(
 	 *
 	 * TODO: this should be done when the command is first used!
 	 */
-	if (nntp_caps.type != CAPABILITIES) {
+	if (nntp_caps.type != CAPABILITIES && nntp_caps.over) {
 		int i, j = 0;
 
+		nntp_caps.over_cmd = NULL;
 		for (i = 0; i < 2 && j >= 0; i++) {
-			j = new_nntp_command(&xover_cmds[i], ERR_NCING, line, sizeof(line));
+			j = new_nntp_command(&xover_cmds[i], ERR_NCING, NULL, 0);
 			switch (j) {
 				case ERR_COMMAND:
 					break;
@@ -1794,47 +1977,55 @@ nntp_open(
 					break;
 			}
 		}
-		for (i = j = 0; i < 2 && j >= 0; i++) {
-			j = new_nntp_command(&xhdr_cmds[i], ERR_CMDSYN, line, sizeof(line));
-			switch (j) {
-				case ERR_COMMAND:
-					break;
-
-				case 221:	/* unexpected multiline ok, e.g.: SoftVelocity Discussions 2.5q */
-					nntp_caps.hdr_cmd = &xhdr_cmds[i];
-#	ifdef DEBUG
-					if ((debug & DEBUG_NNTP) && verbose > 1)
-						debug_print_file("NNTP", "nntp_open() %s skipping data", &xhdr_cmds[i]);
-#	endif /* DEBUG */
-					while (tin_fgets(FAKE_NNTP_FP, FALSE))
-						;
-					j = -1;
-					break;
+		if (!*nntp_caps.over_cmd)
+			nntp_caps.over = FALSE;
 
-				default:	/* usually ERR_CMDSYN (args missing), Typhoon/Twister sends ERR_NCING */
-					nntp_caps.hdr_cmd = &xhdr_cmds[i];
-					j = -1;
-					break;
+		/* TODO; delay check till needed */
+		if (nntp_caps.hdr) {
+			for (i = j = 0; i < 2 && j >= 0; i++) {
+				j = new_nntp_command(&xhdr_cmds[i], ERR_CMDSYN, NULL, 0);
+				switch (j) {
+					case ERR_COMMAND:
+						break;
+
+					case OK_XHDR:	/* unexpected multiline ok, e.g.: SoftVelocity Discussions 2.5q */
+						nntp_caps.hdr_cmd = &xhdr_cmds[i];
+#	ifdef DEBUG
+						if ((debug & DEBUG_NNTP) && verbose > 1)
+							debug_print_file("NNTP", "nntp_open() %s skipping data", &xhdr_cmds[i]);
+#	endif /* DEBUG */
+						while (tin_fgets(FAKE_NNTP_FP, FALSE))
+							;
+						j = -1;
+						break;
+
+					default:	/* usually ERR_CMDSYN (args missing), Typhoon/Twister sends ERR_NCING */
+						nntp_caps.hdr_cmd = &xhdr_cmds[i];
+						j = -1;
+						break;
+				}
 			}
 		}
 		/* no XPAT probing here, we do when it's needed */
-		nntp_caps.xpat = TRUE;
-#	if 0
-		switch (new_nntp_command("XPAT Newsgroups <0> *", ERR_NOART, line, sizeof(line))) {
-			case ERR_NOART:
-				nntp_caps.xpat = TRUE;
-				break;
-
-			default:
-				break;
-		}
-#	endif /* 0 */
+		nntp_caps.xpat = (strstr(serverrc.disabled_nntp_cmds, "XPAT") != NULL) ? FALSE : TRUE;
 	} else {
-		if (!nntp_caps.over_cmd) {
+		/*
+		 * XZVER (and XZHDR) are likely not mentioned in CAPABILITIES
+		 * so we would need to probe them unconditionally.
+		 * responses (note the -1 in size-paraeter):
+		 * - ERR_CMDSYN  = ok (not in a group)
+		 * - ERR_COMMAND = error
+		 * - OK_XOVER    = data follows
+		 *                 =ybegin line=128 size=-1
+		 *                 yenc encoded zcompressed data
+		 *                 =yend crc32=...
+		 *                 .
+		 */
+		if (nntp_caps.type == CAPABILITIES && !nntp_caps.over_cmd && !strstr(serverrc.disabled_nntp_cmds, "XOVER")) {
 			/*
 			 * CAPABILITIES didn't mention OVER or XOVER, try XOVER
 			 */
-			switch (new_nntp_command(xover_cmds, ERR_NCING, line, sizeof(line))) {
+			switch (new_nntp_command(xover_cmds, ERR_NCING, NULL, 0)) {
 				case ERR_COMMAND:
 					break;
 
@@ -1853,11 +2044,17 @@ nntp_open(
 					break;
 			}
 		}
-		if (!nntp_caps.hdr_cmd) {
+
+		if (!nntp_caps.hdr_cmd && !strstr(serverrc.disabled_nntp_cmds, "XHDR")) {
+			/* NOTE:
+			 * FEEDBASE 0.3 (feedbase-nntpd.pl 0.3; feedbase.org; nntps on port 563)
+			 * an Atom/RSS-feed to nntp gateway doesn't like this, use
+			 * disabled_nntp_cmds=XHDR,NEWGROUPS,LISTGROUP
+			 */
 			/*
 			 * CAPABILITIES didn't mention HDR or XHDR, try XHDR
 			 */
-			switch (new_nntp_command(xhdr_cmds, ERR_NCING, line, sizeof(line))) {
+			switch (new_nntp_command(xhdr_cmds, ERR_NCING, NULL, 0)) {
 				case ERR_COMMAND:
 					break;
 
@@ -1878,15 +2075,13 @@ nntp_open(
 		}
 	}
 
-	if (!nntp_caps.over_cmd) {
-		if (!is_reconnect && !batch_mode) {
-			wait_message(2, _(txt_no_xover_support));
+	if (!is_reconnect && !batch_mode && !nntp_caps.over_cmd && !strstr(serverrc.disabled_nntp_cmds, "OVER")) {
+		wait_message(2, _(txt_no_xover_support));
 
-			if (tinrc.cache_overview_files)
-				wait_message(2, _(txt_caching_on));
-			else
-				wait_message(2, _(txt_caching_off));
-		}
+		if (serverrc.cache_overview_files)
+			wait_message(2, _(txt_caching_on));
+		else
+			wait_message(2, _(txt_caching_off));
 	}
 #	if 0
 	else {
@@ -1902,7 +2097,11 @@ nntp_open(
 #	endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
 
 	/* no no_write logic here as that's always set on initial connect */
-	if (((nntp_caps.type == CAPABILITIES && nntp_caps.list_motd) || nntp_caps.type != CAPABILITIES) && !is_reconnect && !batch_mode && show_description && check_for_new_newsgroups) {
+	if (!is_reconnect) {
+		list_distrib_pats();
+		list_distributions();
+	}
+	if (nntp_caps.list_motd && !is_reconnect && !batch_mode && show_description && check_for_new_newsgroups) {
 		FILE *fp;
 
 		if ((fp = tin_fopen(local_motd_file, "w+")) != NULL) {
@@ -1910,7 +2109,7 @@ nntp_open(
 			unsigned int n;
 			long m_hash = list_motd(fp);
 
-			if (m_hash != motd_hash) {
+			if (m_hash != serverrc.motd_hash) {
 				if (fseek(fp, 0L, SEEK_SET) != -1) {
 					n = 0;
 #	ifdef HAVE_COLOR
@@ -1930,7 +2129,7 @@ nntp_open(
 					} else
 						unlink(local_motd_file);
 
-					motd_hash = m_hash;
+					serverrc.motd_hash = m_hash;
 				} /* else EBADF */
 			}
 			fclose(fp);
@@ -1951,7 +2150,7 @@ nntp_open(
 #	endif /* USE_ZLIB */
 #endif /* NNTP_ABLE */
 
-	DEBUG_IO((stderr, "nntp_open okay\n"));
+	DEBUG_IO((stderr, "%snntp_open okay\n", logtime()));
 	return 0;
 }
 
@@ -2014,7 +2213,7 @@ get_only_respcode(
 	respcode = (int) strtol(ptr, &end, 10);
 	if (end == ptr || respcode < 100 || respcode > 599)
 		respcode = -1;
-	DEBUG_IO((stderr, "get_only_respcode(%d)\n", respcode));
+	DEBUG_IO((stderr, "%sget_only_respcode(%d)\n", logtime(), respcode));
 
 	/*
 	 * we also reconnect on ERR_FAULT if last_put was ARTICLE or LIST or POST
@@ -2023,10 +2222,16 @@ get_only_respcode(
 	 * what about other LIST cmds? (ACTIVE|COUNTS|OVERVIEW.FMT|...)
 	 */
 	if (*last_put && ((respcode == ERR_FAULT && (!strncmp(last_put, "ARTICLE", 7) || !strcmp(last_put, "POST") || !strcmp(last_put, "LIST"))) || respcode == ERR_GOODBYE || respcode == OK_GOODBYE) && strcmp(last_put, "QUIT")) {
-		if (respcode == ERR_GOODBYE && !strncmp(last_put, "HEAD ", 5)) {
+		if (respcode == ERR_GOODBYE) {
+			/* don't retry to auth on ERR_GOODBYE */
+			if (!strncmp(last_put, "AUTHINFO ", 9))
+				tin_done(EXIT_FAILURE, ptr);
+
 			/* usenetfarm may send ERR_GOODBYE in response to HEAD, we don't want to retry that */
-			return respcode;
+			if (!strncmp(last_put, "HEAD ", 5))
+				return respcode;
 		}
+
 		/*
 		 * Maybe server timed out.
 		 * If so, retrying will force a reconnect.
@@ -2053,7 +2258,7 @@ get_only_respcode(
 		respcode = (int) strtol(ptr, &end, 10);
 		if (end == ptr || respcode < 100 || respcode > 599)
 			respcode = -1;
-		DEBUG_IO((stderr, "get_only_respcode(%d)\n", respcode));
+		DEBUG_IO((stderr, "%sget_only_respcode(%d)\n", logtime(), respcode));
 	}
 	if (message != NULL && mlen > 1 && *end != '\0')		/* Pass out the rest of the text */
 		my_strncpy(message, ++end, mlen - 1);
@@ -2112,7 +2317,7 @@ get_respcode(
 				can_post = TRUE && !force_no_post;
 		}
 		if (curr_group != NULL) {
-			DEBUG_IO((stderr, _("Rejoin current group\n")));
+			DEBUG_IO((stderr, "%sRejoin current group\n", logtime()));
 			snprintf(last_put, sizeof(last_put), "GROUP %s", curr_group->name);
 			put_server(last_put, FALSE);
 			if (nntpbuf_gets(last_put, NNTP_STRLEN, &nntp_buf) == NULL)
@@ -2121,7 +2326,7 @@ get_respcode(
 			if (debug & DEBUG_NNTP)
 				debug_print_file("NNTP", "<<<%s%s", logtime(), *last_put ? last_put : "NULL");
 #	endif /* DEBUG */
-			DEBUG_IO((stderr, _("Read (%s)\n"), *last_put ? last_put : txt_null));
+			DEBUG_IO((stderr, "%sget_respcode() Read (%s)\n", logtime(), *last_put ? last_put : txt_null));
 		}
 		STRCPY(last_put, savebuf);
 
@@ -2170,7 +2375,7 @@ nntp_command(
 	char *message,
 	size_t mlen)
 {
-DEBUG_IO((stderr, "nntp_command(%s)\n", command));
+DEBUG_IO((stderr, "%snntp_command(%s)\n", logtime(), command));
 #	ifdef DEBUG
 	if ((debug & DEBUG_NNTP) && verbose > 1)
 		debug_print_file("NNTP", "nntp_command(%s)", command);
@@ -2209,7 +2414,7 @@ new_nntp_command(
 {
 	int respcode = 0;
 
-DEBUG_IO((stderr, "new_nntp_command(%s)\n", command));
+DEBUG_IO((stderr, "%snew_nntp_command(%s)\n", logtime(), command));
 #	ifdef DEBUG
 	if ((debug & DEBUG_NNTP) && verbose > 1)
 		debug_print_file("NNTP", "new_nntp_command(%s)", command);
@@ -2220,7 +2425,7 @@ DEBUG_IO((stderr, "new_nntp_command(%s)\
 		if ((respcode = get_respcode(message, mlen)) != success) {
 #	ifdef DEBUG
 			if ((debug & DEBUG_NNTP) && verbose > 1)
-				debug_print_file("NNTP", "new_nntp_command(%s) NOT_OK - Expected: %d, got: %d", command, success, respcode);
+				debug_print_file("NNTP", "new_nntp_command(%s) NOT_OK - Expected: %d, got: %d %s", command, success, respcode, message);
 #	endif /* DEBUG */
 			return respcode;
 		}
